﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CancelTask
{
	public partial class Form1 : Form
	{
		private CancellationTokenSource cancelTokenSource;

		public Form1()
		{
			InitializeComponent();
		}

		private void runButton_Click(object sender, EventArgs e)
		{
			Run();
		}

		private void cancelButton_Click(object sender, EventArgs e)
		{
			cancelTokenSource.Cancel();
		}

		private async void Run()
		{
			cancelTokenSource = new CancellationTokenSource();
			CancellationToken token = cancelTokenSource.Token;

			Task<object> task1 = Task.Factory.StartNew<object>(LongCalcAsync, token);

			dynamic res = await task1;
			if (res != null)
				progressText.Text = $"Sum: {res.Sum}";
			else
				progressText.Text = "Canceled";
		}

		private object LongCalcAsync()
		{
			int sum = 0;
			for (int i = 0; i < 100; i++)
			{
				if (cancelTokenSource.Token.IsCancellationRequested)
					return null;

				sum += i;
				Thread.Sleep(1000);
			}

			return new { Sum = sum };
		}
	}
}
