﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace UseTask
{
	internal class CreateTask
	{
		// Task: similar with ThredPool but more faster and flexible
		public static void StartNew()
		{
			Task.Factory.StartNew(new Action<object>(Run), null);
			Task.Factory.StartNew(new Action<object>(Run), "1st");
			Task.Factory.StartNew(Run, "2nd");
		}

		public static void StartWait()
		{
			Task t1 = new Task(new Action<object>(Run), "1st");
			Task t2 = new Task(() =>
			{
				Console.WriteLine("Long Query");
			});

			t1.Start();
			t2.Start();

			t1.Wait();
			t2.Wait();
		}

		// Task<T>: T is return type
		public static void CreateGenericTask()
		{
			Task<int> task = Task.Factory.StartNew<int>(() => CalcSize("Hello World!"));
			
			Thread.Sleep(1000);

			int result = task.Result;

			Console.WriteLine($"Result={result}");
		}

		private static void Run(object data)
		{
			Console.WriteLine(data == null ? "NULL" : data);
		}

		private static int CalcSize(string data)
		{
			string s = data == null ? "" : data.ToString();
			return s.Length;
		}
	}
}
